package cm.bound.admin;

import cm.bound.Log;
import cm.bound.admin.command.Command;
import cm.utils.L10N;
import cm.utils.SocketUtil;
import java.io.ObjectInputStream;
import java.net.ServerSocket;
import java.net.Socket;
import javax.net.ServerSocketFactory;

/**
 * $Rev: 68 $ <br/>
 * $Date: 2005-03-06 17:02:22 +0900 (Sun, 06 Mar 2005) $ <br/>
 * $Author: C.M $
 * <p/>
 * ǗR}htpT[oXbh\NXB
 */
public class AdminServer extends Thread{
  private static final L10N L10N = new L10N("cm.bound.admin.AdminServer");

  private int _adminport;

  public AdminServer(int port){
    _adminport = port;
  }
  public void run(){
    try{
      ServerSocketFactory ssFactory = SocketUtil.getServerSocketFactory(null);
      ServerSocket serverSocket = ssFactory.createServerSocket(_adminport);
      String info = L10N.getString("enableAdminPort", String.valueOf(_adminport));
      Log.getSysLogger().info(info);
      Log.getConsoleLogger().info(info);
      Socket cSocket = null;
      while(true){
        try{
          cSocket = serverSocket.accept();
          if(cSocket!=null) {
            String msg = L10N.getString("acceptAdminConnectionInfo", cSocket.toString());
            Log.getAccessLogger().info(msg);
            if(Log.getConsoleLogger().isDebugEnabled()){
              Log.getConsoleLogger().debug(msg);
            }
          }
          ObjectInputStream ois = new ObjectInputStream(cSocket.getInputStream());
          Command comm = (Command)ois.readObject();
          comm.setSocket(cSocket);
          comm.execute();
          ois.close();
        }catch(Exception e){
          String error = L10N.getString("adminServerThreadGotError", String.valueOf(_adminport));
          Log.getSysLogger().error(error, e);
          Log.getConsoleLogger().error(error,e);
        }finally{
          if(cSocket != null)cSocket.close();
        }
      }
    }catch(Exception e){
      String error = L10N.getString("adminServerThreadGotError", String.valueOf(_adminport));
      Log.getSysLogger().error(error, e);
      Log.getConsoleLogger().error(error,e);
    }
  }
}
