package cm.bound.handler;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;

/**
 * $Rev: 63 $ <br/>
 * $Date: 2005-03-03 23:15:35 +0900 (Thu, 03 Mar 2005) $ <br/>
 * $Author: C.M $
 * <p/>
 * \Pbg̐ڑԂ`FbNnhB
 */
public class CheckSocketHandler extends SocketHandler{

  String[] _acceptableAddrs;

  /**
  * ڑAhXXg accebtableAddrs w肵
  * CheckSocketHandler쐬B
  * @param acceptableAddrs ڑAhXXg
  */
  public CheckSocketHandler(String[] acceptableAddrs){
    _acceptableAddrs = acceptableAddrs;
  }

 /**
  * s ɂĈȉ`FbNA`FbNOK̏ꍇɂ s ̂܂ܕԂB<p/>
  *  a) s ɐڑς݂ǂ<br/>
  *  b) s RXgN^Ɏw肵AhXXgɊ܂܂邩ǂ <p/>
  * `FbNNG̏ꍇAHandlerException X[B
  * @param s ڑ\PbgB
  * @return ڑ̃\PbgB
  * @exception s ڑ̏ꍇB
  */
  protected Socket handleConnect(Socket s) throws HandlerException{
    if(!s.isConnected()) throw new HandlerException("Socket is not connected");
    if(_acceptableAddrs != null && _acceptableAddrs.length > 0){
      if(!isAcceptable(s, _acceptableAddrs)){
        throw new HandlerException(s.getInetAddress().getHostAddress() + " is not accepted to connect.");
      }
    }
    return s;
  }

  /**
   * ̃NX̎ł handleclose ͉ȂB
   */
  protected  void handleClose() throws HandlerException{
    //doNothing
  }

  private boolean isAcceptable(Socket s, String[] canonAddrs){
    if(s.getInetAddress().isLoopbackAddress()) return true;
    boolean[] ok = new boolean[canonAddrs.length];
    for(int i = 0; i<canonAddrs.length; i++){
      String[] canonStr = canonAddrs[i].split("\\.");
      String[] targetStr;
      if(isAddress(canonStr)){
        targetStr = s.getInetAddress().getHostAddress().split("\\.");
      }else{
        targetStr = s.getInetAddress().getCanonicalHostName().split("\\.");
      }
      ok[i] = check(targetStr, canonStr);
    }
    for(int i = 0; i<ok.length; i++){
      if(ok[i])return true;
    }
    return false;
  }

  private boolean check(String targetAddr[], String canonAddr[]){
    boolean ok = true;
    int j = canonAddr.length;
    for(int k = targetAddr.length-1; k >= 0 ; k--){
      if(!targetAddr[k].equalsIgnoreCase(canonAddr[j-1])){
        if(!canonAddr[j-1].equals("*")){
          return false;
        }
      }
      j -= 1;
      if(j<1)break;
    }
    return ok;
  }

  private boolean isAddress(String[] addrStr){
    boolean isAddress = true;
    for(int i = 0; i<addrStr.length; i++){
      if(!addrStr[i].equals("*")){
        try{
          Integer.parseInt(addrStr[i]);
        }catch(NumberFormatException e){
          return false;
        }
      }
    }
    return isAddress;
  }
}
