package cm.bound.handler;

import cm.security.Key;
import cm.utils.SocketUtil;
import java.net.Socket;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;

/**
 * $Rev: 46 $ <br/>
 * $Date: 2005-02-18 15:41:46 +0900 (Fri, 18 Feb 2005) $ <br/>
 * $Author: C.M $
 * <p/>
 * SSL ڑɊւ鏈{邽߂̃nhB
 */
public class SSLSocketHandler extends SocketHandler
{
  private InputStream _sourceIn;
  private OutputStream _sourceOut;
  private String _forwardHost;
  private int _forwardPort;
  private Key _key;
  private boolean _ignoreServerAuth;

  /**
   * forwardHost, forwardPort Ŏw肵ڑ SSLSocketHandler 쐬B
   * L[XgAKvȏꍇ(قƂǃT[oŃNCAgF؂vꍇɌ)
   * keyw肷邱ƁBL[XgAKvȂ key null w肵Ă悢B
   * T[oF؂𖳎ꍇ́AignoreServerAuth  trueɂ邱ƁB
   */
  public SSLSocketHandler(String forwardHost, int forwardPort, Key key, boolean ignoreServerAuth){
    _forwardHost = forwardHost;
    _forwardPort = forwardPort;
    _key = key;
    _ignoreServerAuth = ignoreServerAuth;
  }

  /**
   * s ƂȂ\PbgARXgN^Ŏw肵ڑ𗝘_ڑƂ
   * SSL nhVFCN{B
   * @return SSL nhVFCN{ʂ SSL \PbgB
   * @exception SSL nhVFCNɊւāA炩̃G[ꍇB
   **/
  protected Socket handleConnect(Socket s) throws HandlerException{
    try{
      _sourceIn = s.getInputStream();
      _sourceOut = s.getOutputStream();
      return doSSLHandshake(s, _forwardHost, _forwardPort);
    }catch(Exception e){
      throw new HandlerException(e);
    }
  }

  /**
   * handleConnect Ŏw肵ƂȂ\Pbg̃Xg[N[YB
   * @exception \PbgXg[̃N[Yɓo̓G[ꍇB
   **/
  protected void handleClose() throws HandlerException{
    /*
      memo:
      SSLgl̏ꍇASSL\PbgXg[ȂN[Y
      ł܂Ă܂(ubN͗l)Ȃ̂ŁAKɌɂȂ
      ʏ\PbgXg[ɃN[Y悤ɂB
    */
    try{
      if(_sourceIn != null)_sourceIn.close();
      if(_sourceOut != null)_sourceOut.close();
    }catch(Exception e){
      throw new HandlerException(e);
    }
  }

  /**
  * SSL ɂnhVFCNsB
  * @param s ʂ̃\Pbg( SSL gl̏ꍇ̓vLVւ̐ڑ\Pbg)B
  * @param host _ڑ̃zXgB
  * @param port _ڑ̃|[gB
  * @exception o̓G[ꍇB
  */
  private Socket doSSLHandshake(Socket s, String host, int port) throws IOException{
    SSLSocketFactory factory = (SSLSocketFactory)SocketUtil.getSocketFactory(_key, _ignoreServerAuth);
    SSLSocket sslSocket = (SSLSocket)factory.createSocket(s, host, port, true);
    sslSocket.startHandshake();
    return sslSocket;
  }
}
