package cm.bound.handler;

import cm.io.HttpProperty;
import cm.utils.L10N;
import cm.utils.StreamUtil;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

/**
 * $Rev: 29 $ <br/>
 * $Date: 2004-10-14 19:11:29 +0900 (Thu, 14 Oct 2004) $ <br/>
 * $Author: C.M $
 * <p/>
 * gl ڑɊւ鏈{邽߂̃nhB
 */
public class TunnelSocketHandler extends SocketHandler implements HttpProperty
{
  private static final L10N L10N = new L10N("cm.bound.handler.TunnelSocketHandler");

  private String _forwardHost;
  private int _forwardPort;
  private String _proxyAuthString;

  /**
   * w肵 forwardHost, forwardPort ڑƂāATunnelSocketHandler 쐬B
   * proxyAuthString ̓vLVւ̊{F؂Ɏgp郆[U ID pX[h : (R) 
   * qABase64 GR[hB
   */
  public TunnelSocketHandler(String forwardHost, int forwardPort, String proxyAuthString){
    _forwardHost = forwardHost;
    _forwardPort = forwardPort;
    _proxyAuthString = proxyAuthString;
  }

  /**
   * vLVT[oւ̊{F؂͂ȂƂOɁAw肵 forwardHost, forwardPort ڑƂāA
   * TunnelSocketHandler 쐬B
   */
  public TunnelSocketHandler(String forwardHost, int forwardPort){
    this(forwardHost, forwardPort, null);
  }

  /**
   * RXgN^Ŏw肵ڑɃglڑB\Pbg s ͈ʓIɃvLVT[oւ̐ڑ\PbgB
   * ȂAvLVT[oւ̐ڑ́AHTTP  CONNECT \bhgpB
   * @return glڑ\PbgB
   * @exception glڑɎsꍇB
   */
  protected Socket handleConnect(Socket s) throws HandlerException{
    try{
      doTunnelHandshake(s);
      return s;
    }catch(Exception e){
      throw new HandlerException(e);
    }
  }

  /**
  * ̃NX̎ł handleClose ͉ȂB
  */
  protected void handleClose() throws HandlerException{
    //doNothing
  }

  private void doTunnelHandshake(Socket proxy) throws IOException{
    StringBuffer sb = new StringBuffer();
    sb.append(CONNECT_METHOD);
    sb.append(" ");
    sb.append(_forwardHost);
    sb.append(":");
    sb.append(_forwardPort);
    sb.append(" ");
    sb.append(HTTP_1_0);
   	//vLV CONNECT vo
    OutputStream out = proxy.getOutputStream();
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    byte[] connectMethod = sb.toString().getBytes(HEADER_ENC);
    baos.write(connectMethod);
    baos.write(HTTP_CRLF);
    if(_proxyAuthString != null){
      baos.write("Proxy-Authorization: Basic ".getBytes(HEADER_ENC));
      baos.write(_proxyAuthString.getBytes(HEADER_ENC));
      baos.write(HTTP_CRLF);
    }
    baos.write(HTTP_CRLF);
    byte connectRequest[] = baos.toByteArray();
    out.write(connectRequest);
    out.flush();
    baos.close();

    //vLV̕ԓ𓾂Xg[
    InputStream	in = proxy.getInputStream();
    boolean	error = false;

    byte[] replyFirstLine = StreamUtil.readLine(in);
    ByteArrayOutputStream buf = new ByteArrayOutputStream();
    buf.write(replyFirstLine);
    //vLV̉͐HsĂ
    byte[] line;
    while((line = StreamUtil.readLine(in)) != null){
      buf.write(line);
      if(line.length == 2 && line[0] == '\r' && line[1] == '\n'){
        break;
      }
    }
    buf.close();

    //
    String replyFirstLineStr = new String(replyFirstLine, HEADER_ENC);
    if (replyFirstLineStr.startsWith(HTTP_1_0 + " 200")
      || replyFirstLineStr.startsWith(HTTP_1_1 + " 200")) {
      return;
    }else{
      String[] s = new String[2];
      s[0] = _forwardHost + ":" + _forwardPort;
      s[1] = buf.toString(HEADER_ENC);
      throw new IOException(L10N.getString("unableToTunnelError",s ));
    }
  }

}
