package cm.io;

import java.io.BufferedOutputStream;
import java.io.FilterOutputStream;
import java.io.IOException;
import java.io.OutputStream;

/**
 * $Rev: 53 $ <br/>
 * $Date: 2005-03-02 00:10:14 +0900 (Wed, 02 Mar 2005) $ <br/>
 * $Author: C.M $
 * <p/>
 * ʏ̏o͂ƓɃ_vo͂񋟂NXB
 */
public class DumpOutputStream extends FilterOutputStream
{
  private OutputStream _dumper;

  /**
  * w肳ꂽ out, dumper  DumpOutputStream 쐬B
  * @param out ʏ̏o̓Xg[B
  * @param dumper _v̏o̓Xg[B
@* @exception ڑɊւăG[ꍇB
  */
  public DumpOutputStream(OutputStream out, OutputStream dumper) throws IOException{
    super(out);
    setDumper(dumper);
  }

  /**
  * _v̏o̓Xg[Đݒ肷Bɐݒ肳Ăꍇ́A
  * Â_vo̓Xg[̓N[YB
  * @param dumper _v̏o̓Xg[B
  * @exception o̓G[ꍇB
  */
  public synchronized void setDumper(OutputStream dumper) throws IOException{
    if(_dumper != null) _dumper.close();
    _dumper = dumper;
  }

  /**
  * ʏo̓Xg[ƃ_vXg[Ɏw肵 i ށB
  * @param i ݃f[^B
  * @exception o̓G[ꍇB
  */
  public synchronized void write(int i) throws IOException{
    out.write(i);
    _dumper.write(i);
  }

  /**
  * ʏo̓Xg[ƃ_vXg[Ɏw肵oCg bytes ށB
  * @param bytes ރoCgB
  * @exception o̓G[ꍇB
  */
  public synchronized void write(byte[] bytes) throws IOException{
    out.write(bytes);
    _dumper.write(bytes);
  }

  /**
  * ʏo̓Xg[ƃ_vXg[Ɏw肵oCg bytes
  * ̃ItZbg off  oCg len ̃f[^ށB
  * @param bytes ރoCgB
  * @param off ރoCg bytes ̊JnItZbgB
  * @param len  ރoCgB
  * @exception o̓G[ꍇB
  */
  public synchronized void write(byte[] bytes, int off, int len) throws IOException
  {
    out.write(bytes, off, len);
    _dumper.write(bytes, off, len);
  }

  /**
  * obt@Oꂽo̓Xg[tbVB
  * @exception o̓G[ꍇB
  */
  public synchronized void flush() throws IOException{
    out.flush();
    _dumper.flush();
  }

  /**
  * o̓Xg[N[YB
  * @exception o̓G[ꍇB
  */
  public synchronized void close() throws IOException{
    out.close();
    if(_dumper != null) _dumper.close();
  }
}
