package cm.io;

import java.io.EOFException;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;

/**
 * $Rev: 22 $ <br/>
 * $Date: 2004-10-09 17:20:43 +0900 (Sat, 09 Oct 2004) $ <br/>
 * $Author: C.M $
 * <p/>
 * GZIPPackOutputStream ɑ΂ ̓WJXg[񋟂NXB
 * @see cm.io.GZIPPackOutputStream
 */
public class GZIPPackInputStream extends FilterInputStream
{
  /**
   * GZIP WJꂽoCgێtB[hB
   */
  protected byte[] _remain = null;

  /**
  * w肳ꂽ in  GZIPPackInputStream 쐬B
  * @param in ƂȂ̓Xg[B
  * @exception o̓G[ꍇB
  */
  public GZIPPackInputStream(InputStream in) throws IOException{
    super(new ObjectInputStream(in));
   }

  /**
  * ƂȂXg[ GZIP WJA1 oCgǂݍŕԂB
  * @return GZIP WJꂽf[^ 1 oCgB
  * @exception o̓G[ꍇB
  */
  public int read() throws IOException{
    byte[] b = new byte[1];
    read(b, 0, 1);
    return b[0];
  }

  /**
   * GZIP WJς݃f[^ _remain tB[h̒ԂB
   * _remain  null ̏ꍇ 0 ԂB܂A
   * GZIP WJ{ȂĂoCgԂB
   * @return GZIP WJς݃oCgB
   */
  public int available(){
    if(_remain != null) return _remain.length;
    return 0;
  }

  /**
  * ̃\bh read(bytes, 0, bytes.length) R[ꍇƓłB
  */
  public int read(byte[] bytes) throws IOException{
    return read(bytes, 0, bytes.length);
  }

  /**
  * w肵obt@ bytes ̃ItZbg off@ len oCg
  * ƂȂ̓Xg[ GZIP WJꂽf[^i[B
  * xɓWJꂽf[^ bytes Ɏ܂ȂꍇAc̓WJf[^
  * _remain tB[hɕێĂA read R[Ɏgpł悤ɂB
  * @param bytes i[obt@B
  * @param off f[^i[ItZbgB
  * @param len f[^i[oCgB
  * @exception o̓G[ꍇB
  */
  public synchronized int read(byte[] bytes, int off, int len) throws IOException
  {
    if(off < 0 || off + len > bytes.length) throw new IndexOutOfBoundsException();
    if(_remain == null){
      try{
        ObjectInputStream objin = (ObjectInputStream)in;
        GZIPPack pack = (GZIPPack)objin.readObject();
        _remain = pack.getBytes();
      }catch(EOFException eof){
        return -1;
      }catch(ClassNotFoundException e){return -1;/*肠Ȃ*/}
    }
    int ret = 0;
    if(_remain.length > 0){
      if(_remain.length <= len){
        System.arraycopy(_remain, 0,
                           bytes, off, _remain.length);
        ret = _remain.length;
        _remain = null;
      }else{
        System.arraycopy(_remain, 0, bytes, off, len);
        ret = len;
        byte[] new_remain = new byte[_remain.length - len];
        System.arraycopy(_remain, len,
                           new_remain, 0, new_remain.length);
        _remain = new_remain;
      }
    }
    return ret;
  }

  public void close() throws IOException{
    super.close();
    _remain = null;
  }
}
