package cm.io;

import java.io.ByteArrayOutputStream;
import java.io.FilterOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.OutputStream;

/**
 * $Rev: 79 $ <br/>
 * $Date: 2005-03-11 13:26:13 +0900 (Fri, 11 Mar 2005) $ <br/>
 * $Author: C.M $
 * <p/>
 * GZIP ɂ鈳kXg[񋟂NXBo͂Xg[ GZIPPackInputStream œWJłB
 * @see cm.io.GZIPPackInputStream
 */
public class GZIPPackOutputStream extends FilterOutputStream implements StreamProperty
{
  /**
   * kÕoCgێtB[hB
   */
  protected ByteArrayOutputStream _buf;

  /**
  * w肳ꂽ out  GZIPPackInputStream 쐬B
  * @param out o͐ƂȂXg[B
  * @exception o̓G[ꍇB
  */
  public GZIPPackOutputStream(OutputStream out) throws IOException{
    super(new ObjectOutputStream(out));
    _buf = new ByteArrayOutputStream(BUFFER_SIZE);
   }

  /**
  * ŕێoCgo̓Xg[ _buf  i ށB
  * @exception o̓G[ꍇB
  * */
  public void write(int i) throws IOException{
    _buf.write(i);
  }

  /**
  * ̃\bh write(bytes, 0, bytes.length) R[ꍇƓłB
  * @exception o̓G[ꍇB
  */
  public void write(byte[] bytes) throws IOException{
    write(bytes, 0, bytes.length);
  }

  /**
  * ŕێoCgo̓Xg[ _buf Ɏw肵oCg bytes
  * ̃ItZbg off  oCg len ̃f[^ށB
  * @param bytes ރoCgB
  * @param off ރoCg bytes ̊JnItZbgB
  * @param len  ރoCgB
  * @exception o̓G[ꍇB
  */
  public void write(byte[] bytes, int off, int len) throws IOException
  {
    _buf.write(bytes, off, len);
  }

  /**
  * _buf ێoCg GZIP kĂRXgN^Ɏw肵
  * o͐ɃtbVB̃\bhR[܂ňkf[^͈
  * tbVȂƂɒӂ邱ƁBOutOfMemory 邽߂ɒI
  *  flush R[邱ƁB
  * @exception o̓G[ꍇB
  */
  public synchronized void flush() throws IOException{
    if(_buf.size() > 0){
      GZIPPack pack = new GZIPPack(_buf.toByteArray());
      ObjectOutputStream objout = (ObjectOutputStream)out;
      objout.writeObject(pack);
      _buf.reset();
      super.flush();
    }
  }

  public void close() throws IOException{
    super.close();
    _buf.close();
  }
}
