package cm.security;

import java.security.KeyStore;
import java.security.SecureRandom;
import javax.net.ssl.KeyManager;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.TrustManagerFactory;

/**
 * $Rev: 46 $ <br/>
 * $Date: 2005-02-18 15:41:46 +0900 (Fri, 18 Feb 2005) $ <br/>
 * $Author: C.M $
 * <p/>
 * SSLɊւ郆[eBeBW߂NX
*/
public class SSLUtil{

  private static String _protocol = "SSL";

  /**
   * SSLContextԂBSSLContext̏ɕKvKeyManagerTrustManager
   * 擾@͈ȉ̂ƂB<br/>
   * KeyManager̎擾@F keynullłȂꍇAkey 瓾 KeyStoreŎ擾Bkey
   * null̏ꍇAKeyManagernullƂB<br/>
   * TrustManager̎擾@F relaxedTrust true ̏ꍇ RelaxedX509TrustManagerƂB
   * relaxedTrust  falsekeynullłȂꍇkey 瓾 KeyStoreŎ擾B
   * relaxedTrust  falsekeynull̏ꍇATrustManagernullƂB<br/>
   * @param key KeyManager, TrustManager̎擾ɎgL[XgAB
   * @param relaxedTrust truȅꍇATrustManagerRelaxedX509TrustManagerƂȂB
   */
  public static SSLContext getSSLContext(Key key, boolean relaxedTrust) throws Exception{
    SSLContext ctx = SSLContext.getInstance(_protocol);
    KeyManager[] km = null;
    TrustManager[] tm = null;
    if(key != null){
      km = getKeyManagers(key);
    }
    if(relaxedTrust){
      tm = new TrustManager[1];
      tm[0] = new RelaxedX509TrustManager();
    }else{
      if(key != null){
        tm = getTrustManagers(key);
      }
    }
    ctx.init(km, tm, new SecureRandom());
    return ctx;
  }

  private static TrustManager[] getTrustManagers(Key key) throws Exception{
    TrustManagerFactory tmf
      = TrustManagerFactory.getInstance(TrustManagerFactory.getDefaultAlgorithm());
    KeyStore ks = getKeyStore(key);
    tmf.init(ks);
    return tmf.getTrustManagers();
  }

  private static KeyManager[] getKeyManagers(Key key) throws Exception{
    KeyManagerFactory kmf
      = KeyManagerFactory.getInstance(KeyManagerFactory.getDefaultAlgorithm());
    KeyStore ks = getKeyStore(key);
    kmf.init(ks, key.getKeyPass());
    return kmf.getKeyManagers();
  }

  private static KeyStore getKeyStore(Key key) throws Exception{
     KeyStore ks = KeyStore.getInstance(key.getStoreType());
     ks.load(key.getKeyAsStream(), key.getStorePass());
     return ks;
  }
}
