package cm.utils;

import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FilterOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import sun.misc.BASE64Encoder;
import sun.misc.CharacterEncoder;
import sun.misc.HexDumpEncoder;

/**
 * $Rev: 22 $ <br/>
 * $Date: 2004-10-09 17:20:43 +0900 (Sat, 09 Oct 2004) $ <br/>
 * $Author: C.M $
 * <p/>
 * RXgN^Ŏw肵o̓oCgXg[Aw肵GR[h@ŃGR[hȂ
 * o͂邽߂̃tB^NXB
 * ̃NX̑SĂ write \bh ̓GR[hʂ̃NXɎobt@ɏłB
 * ]āAo̓oCgXg[ɏo߂ɁAK flush \bhĂԂƁB
*/
public class EncodeOutputStream extends FilterOutputStream
{
  /**
   * oCgGR[hwtB[hB̎wł̓oCgXg[͑SGR[hȂB
   */
  public static final int BYTE   = 0;

  /**
   * Base64 GR[hwtB[hB
   */
  public static final int BASE64 = 1;

  /**
   * Hex _vGR[hwtB[hB
   */
  public static final int HEX    = 2;

  private CharacterEncoder _encoder;
  private ByteArrayOutputStream _buf = new ByteArrayOutputStream();

  private final int _encodeType;

  /**
   * w肵oCgXg[ out ƃGR[h@ type  EncodeOutputStream 쐬B
   * @param out GR[hoCgXg[B
   * @param type GR[h@Bwl̓GR[hwtB[hQƁB
   */
  public EncodeOutputStream(OutputStream out, int type){
    super(out);
    switch(type){
      case BASE64:
        _encoder = new BASE64Encoder();
        break;
      case HEX:
        _encoder = new HexDumpEncoder();
        break;
      case BYTE:
        _encoder = null; // no encode
    }
    _encodeType = type;
  }

  /**
   * w肵oCgGR[hAʂobt@ɏށB
   * @param b GR[hoCgB
   * @exception o̓G[ꍇB
   */
  public void write(int b) throws IOException{
    _buf.write(b);
  }

  /**
   * w肵oCgGR[hAʂobt@ɏށB
   * @param b GR[hoCgB
   * @exception o̓G[ꍇB
   */
  public void write(byte[] b) throws IOException{
    _buf.write(b);
  }

  /**
   * w肵oCg̃ItZbg off n܂ len oCgGR[hAʂobt@ɏށB
   * @param b GR[hoCgB
   * @param off oCg̃ItZbgB
   * @param len GR[hoCgB
   * @exception o̓G[ꍇB
   */
  public void write(byte[] b, int off, int len) throws IOException{
    _buf.write(b, off, len);
  }

  /**
   * obt@RXgN^Ŏw肵o̓Xg[ɏށB
   * @exception o̓G[ꍇB
   */
  public void flush() throws IOException{
    byte[] tmp;
    if(_encodeType == BYTE){
      tmp = _buf.toByteArray();
    }else{
      String encoded = _encoder.encode(_buf.toByteArray());
      tmp = encoded.getBytes();
    }
    _buf.reset();
    out.write(tmp);
    out.flush();
  }

  /**
   * obt@RXgN^Ŏw肵o̓Xg[ɏ񂾌A
   * obt@Əo̓Xg[N[YB
   * @exception o̓G[ꍇB
   */
  public void close() throws IOException{
    flush();
    _buf.close();
    out.close();
  }

  private static void usage(){
    System.out.println("usage   : EncodeOutputStream <METHOD> <STRING> | <METHOD> -file <FILE>");
    System.out.println("<METHOD>: BASE64 | HEX");
  }

  public static void main(String[] args){
    if(args.length <2){
      usage();
      System.exit(0);
    }
    byte[] b = null;
    try{
      if(args.length == 2){
        b = args[1].getBytes();
      }else if(args.length >=3 && args[1].equals("-file")){
        FileInputStream in = new FileInputStream(args[2]);
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        int i;
        while((i = in.read()) != -1){
          out.write(i);
        }
        b = out.toByteArray();
        in.close();
        out.close();
      }else{
        usage();
        System.exit(0);
      }
      int method = -1;
      if(args[0].equalsIgnoreCase("BASE64")){
        method = BASE64;
      }else if(args[0].equalsIgnoreCase("HEX")){
        method = HEX;
      }else{
        System.out.println("Non supported method: " + args[0]);
        System.exit(1);
      }
      EncodeOutputStream enc = new EncodeOutputStream(System.out, method);
      enc.write(b);
      enc.flush();
      enc.close();
    }catch (Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }
}
