package cm.utils;

import java.util.Locale;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * $Rev: 29 $ <br/>
 * $Date: 2004-10-14 19:11:29 +0900 (Thu, 14 Oct 2004) $ <br/>
 * $Author: C.M $
 * <p/>
 * vpeBt@C L10N \[X擾邽߂̃[eBeBNXB
 */
public class L10N
{
  private static final Pattern _replace = Pattern.compile("\\{[0-9]+\\}");
  private static final Pattern _separator = Pattern.compile("\\n");

  private static final String _LINE_SEP = System.getProperty("line.separator");

  private ResourceBundle _resource;

  /**
   * L10N(location, Locale.getDefault()) ɂ L10N 쐬B
   */
  public L10N(String location){
    this(location, Locale.getDefault());
  }

  /**
   * w肵 locationAlocale  L10N 쐬B
   * @param location vpeBt@C̏ꏊB
   * @param locale \[X擾Ώۂ̃P[B
   */
  public L10N(String location, Locale locale){
    _resource = PropertyResourceBundle.getBundle(location);
  }

  /**
   * ̃\bh́AgetString(key, null) R[̂ƓłB
   */
  public String getString(String key){
    String[] dummy = null;
    return getString(key, dummy);
  }

  /**
   * ̃\bh́AString[] replaces = {replace}; getString(key, replaces)
   * R[̂ƓłB
   */
  public String getString(String key, String replace){
    String[] replaces = {replace};
    return getString(key, replaces);
  }

  /**
   * L10N \[X key l𕶎ƂĎ擾Breplaces  null ȊOw肵ꍇA
   * Ɏ̑SĂ̒uƂIʂԂB <p/>
   * 1. 擾̒ <pre> \\{[0-9]+\\} </pre> ̐K\Ƀ}b`̂ replace 
   * eƒuB<br/>
   * 2. <pre> \\n </pre> ̐K\Ƀ}b`̃VXẻsR[h\ƒuB<p/>
   * @param key@L10N \[X̃L[B
   * @param replaces uB
   */
  public String getString(String key, String[] replaces){
    String ret = _resource.getString(key);
    if(replaces != null){
      Matcher matcher = _replace.matcher(ret);
      int i = 0;
      StringBuffer sb = new StringBuffer();
      while(matcher.find() && i < replaces.length){
        matcher.appendReplacement(sb, replaces[i]);
        i += 1;
      }
      ret = matcher.appendTail(sb).toString();
    }
    StringBuffer sb = new StringBuffer();
    Matcher matcher = _separator.matcher(ret);
    while(matcher.find()){
      matcher.appendReplacement(sb, _LINE_SEP);
    }
    ret = matcher.appendTail(sb).toString();
    return ret;
  }
}
