package cm.utils;

import java.io.PrintWriter;
import java.io.Writer;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.apache.log4j.RollingFileAppender;

/**
 * $Rev: 22 $ <br/>
 * $Date: 2004-10-09 17:20:43 +0900 (Sat, 09 Oct 2004) $ <br/>
 * $Author: C.M $
 * <p/>
 * Oo͗pwp[NXBł log4j gpB
 * Ot@C 3000KB Ń[eCVB</br>
 * ܂ACAEg͈ȉŌŒ肳B<pre>"%d{DATE} %-5p : %m%n"</pre>
 */
public class Logging
{
  private final String LAYOUT = "%d{DATE} %-5p : %m%n";
  private final String MAX_LOGFILE_SIZE = "3000KB";

  private Logger _logger;

  /**
   * DEBUG o̓x
   */
  public static final int DEBUG = 4;
  /**
   * INFO o̓x
   */
  public static final int INFO  = 3;
  /**
   * WARN o̓x
   */
  public static final int WARN  = 2;
  /**
   * ERROR o̓x
   */
  public static final int ERROR = 1;
  /**
   * FATAL o̓x
   */
  public static final int FATAL = 0;

  public Logging(String name){
    _logger = Logger.getLogger(name);
  }

  /**
   * Oo͗p̃Ay_w肷B
   * @param writer Oo͂Ɏgp WriterB
   */
  public void addAppender(Writer writer){
    RollingFileAppender ap = new RollingFileAppender();
    ap.setMaxFileSize(MAX_LOGFILE_SIZE);
    ap.setLayout(new PatternLayout(LAYOUT));
    ap.setWriter(writer);
    _logger.addAppender(ap);
  }

  /**
   * Oo̓xݒ肷B
   * @param lv OxB
   */
  public void setLevel(int lv){
     Level l = Level.ALL;
     switch(lv){
       case DEBUG:
        l = Level.DEBUG;
        break;
       case INFO:
        l = Level.INFO;
        break;
       case WARN:
        l = Level.WARN;
        break;
       case ERROR:
        l = Level.ERROR;
        break;
       case FATAL:
        l = Level.FATAL;
     }
    _logger.setLevel(l);
  }

  /**
   * DEBUG o͂sB
   * @param o o͂IuWFNgB
   */
  public void debug( Object o ){ _logger.debug(o); }

  /**
   * DEBUG o͂sB
   * @param o o͂IuWFNgB
   * @param t o͂ThrowableIuWFNgB
   */
  public void debug( Object o, Throwable t ){ _logger.debug(o,t); }

  /**
   * INFO o͂sB
   * @param o o͂IuWFNgB
   */
  public void info( Object o) { _logger.info(o); }

  /**
   * INFO o͂sB
   * @param o o͂IuWFNgB
   */
  public void info( Object o, Throwable t) { _logger.info(o,t); }

  /**
   * WARN o͂sB
   * @param o o͂IuWFNgB
   */
  public void warn( Object o) { _logger.warn(o); }

  /**
   * WARN o͂sB
   * @param o o͂IuWFNgB
   * @param t o͂ThrowableIuWFNgB
   */
  public void warn( Object o, Throwable t) { _logger.warn(o,t); }

  /**
   * ERROR o͂sB
   * @param o o͂IuWFNgB
   */
  public void error( Object o) { _logger.error(o); }

  /**
   * ERROR o͂sB
   * @param o o͂IuWFNgB
   * @param t o͂ThrowableIuWFNgB
   */
  public void error( Object o, Throwable t) { _logger.error(o,t); }

  /**
   * FATAL o͂sB
   * @param o o͂IuWFNgB
   */
  public void fatal( Object o) { _logger.fatal(o); }

  /**
   * FATAL o͂sB
   * @param o o͂IuWFNgB
   * @param t o͂ThrowableIuWFNgB
   */
  public void fatal( Object o, Throwable t) { _logger.fatal(o,t); }

  /**
   * DEBUG o͉\肷B
   * @return DEBUG o͉\ȏꍇ trueBDEBUG o͉\łȂꍇ falseB
   */
  public final boolean isDebugEnabled(){return _logger.isDebugEnabled();}

  /**
   * INFO o͉\肷B
   * @return INFO o͉\ȏꍇ trueBINFO o͉\łȂꍇ falseB
   */
  public final boolean isInfoEnabled() {return _logger.isInfoEnabled();}

  /**
   * WARN o͉\肷B
   * @return WARN o͉\ȏꍇ trueBWARN o͉\łȂꍇ falseB
   */
  public final boolean isWarnEnabled() {return _logger.isEnabledFor(org.apache.log4j.Level.WARN); }

  /**
   * ERROR o͉\肷B
   * @return ERROR o͉\ȏꍇ trueBERROR o͉\łȂꍇ falseB
   */
  public final boolean isErrorEnabled(){return _logger.isEnabledFor(org.apache.log4j.Level.ERROR);}

  /**
   * ERROR o͉\肷B
   * @return ERROR o͉\ȏꍇ trueBERROR o͉\łȂꍇ falseB
   */
  public final boolean isFatalEnabled(){return _logger.isEnabledFor(org.apache.log4j.Level.FATAL);}

  public static void main(String args[]){
     Logging log = new Logging(Logging.class.getName());
     Writer w = new PrintWriter(System.out);
     log.addAppender(w);
     log.setLevel(INFO);

     log.debug("debug");
     log.info("info");
     log.warn("warn");
     log.error("error");
     log.fatal("fatal");

    }
}
